/* IMPORTANT NOTE
 * --------------
 * This is a very fragile demo (eg, typing any character which is not part of the SpriteFont breaks it)
 * but it should sufficiently demonstrate what's going on (ie, WinForms-style events).
 */

#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using System.Text;
#endregion

namespace XnaTextInput {
	public class TextInputGame : Microsoft.Xna.Framework.Game {
		GraphicsDeviceManager graphics;
		ContentManager content;

		// Test object to handle text input:
		private TextInputHandler TextInput;

		// Entered text:
		private StringBuilder CurrentText;

		// Sprite font related gubbins:
		private SpriteBatch ForegroundBatch;
		private SpriteFont Verdana;


		public TextInputGame() {
			graphics = new GraphicsDeviceManager(this);
			content = new ContentManager(Services);
		}


		protected override void Initialize() {
			base.Initialize();

			this.CurrentText = new StringBuilder("Type!");

			this.TextInput = new TextInputHandler(this.Window.Handle);
			this.TextInput.KeyPress += delegate(object sender, System.Windows.Forms.KeyPressEventArgs e) { this.CurrentText.Append(e.KeyChar).Replace('\r', '\n'); };
		}


		protected override void LoadGraphicsContent(bool loadAllContent) {
			if (loadAllContent) {
				this.Verdana = content.Load<SpriteFont>("Verdana");
				this.ForegroundBatch = new SpriteBatch(graphics.GraphicsDevice);
			}
		}
		
		protected override void UnloadGraphicsContent(bool unloadAllContent) {
			if (unloadAllContent) {
				content.Unload();
			}
		}

		protected override void Update(GameTime gameTime) {
			if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
				this.Exit();

			base.Update(gameTime);
		}

		protected override void Draw(GameTime gameTime) {
			graphics.GraphicsDevice.Clear(Color.White);

			this.ForegroundBatch.Begin();

			string TextToDraw = this.CurrentText.ToString();


			ForegroundBatch.DrawString(
				this.Verdana,
				TextToDraw,
				new Vector2(graphics.GraphicsDevice.Viewport.Width, graphics.GraphicsDevice.Viewport.Height) / 2f,
				Color.Black,
				0f, 
				this.Verdana.MeasureString(TextToDraw) / 2f,
				1.0f,
				SpriteEffects.None,
				0.5f
			);

			this.ForegroundBatch.End();


			base.Draw(gameTime);
		}
	}
}
